/*
 * PPM.c
 *
 *  Created on: 8. nov. 2018
 *      Author: sb
 */
#include <stdint.h>
#include "PPM.h"
#include "driverlib.h"
#include "driverlib/timer_a.h"

static uint16_t compareValue;

void PPM_Start()
{
    compareValue = 50000;
}

void PPM_Stop()
{
    compareValue = 20000;
}

void PPM_SetChannel(uint8_t channel, uint16_t value)
{
    compareValue = value;
}

void PPM_Initialize()
{
    compareValue = 50000;

    //Set P1.0 to output direction
    GPIO_setAsOutputPin(GPIO_PORT_PJ, GPIO_PIN0);


    //Start timer in continuous mode sourced by ACLK
    Timer_A_initContinuousModeParam param;
    param.clockSource = TIMER_A_CLOCKSOURCE_ACLK;
    param.clockSourceDivider = TIMER_A_CLOCKSOURCE_DIVIDER_64;
    param.timerInterruptEnable_TAIE = 0;
    param.timerClear = 0;
    param.startTimer = 0;
    /*Timer_A_initContinuousMode(TIMER_A1_BASE, &param);


    //Initialize compare mode
    Timer_A_clearCaptureCompareInterrupt(TIMER_A1_BASE, TIMER_A_CAPTURECOMPARE_REGISTER_0);

    Timer_A_initCompareModeParam param2;
    param2.compareRegister = TIMER_A_CAPTURECOMPARE_REGISTER_0;
    param2.compareInterruptEnable = TIMER_A_CAPTURECOMPARE_INTERRUPT_ENABLE;
    param2.compareOutputMode = TIMER_A_OUTPUTMODE_OUTBITVALUE;
    param2.compareValue = compareValue;
    Timer_A_initCompareMode(TIMER_A1_BASE, &param2);

    Timer_A_startCounter(TIMER_A1_BASE, TIMER_A_CONTINUOUS_MODE);*/
}


#pragma vector=TIMER1_A1_VECTOR
__interrupt void TIMER1_A1_ISR (void)
{
    uint16_t compVal = Timer_A_getCaptureCompareCount(TIMER_A1_BASE,
            TIMER_A_CAPTURECOMPARE_REGISTER_0)
            + compareValue;

    //Toggle P1.0
    GPIO_toggleOutputOnPin(
        GPIO_PORT_PJ,
        GPIO_PIN0
        );

    //Add Offset to CCR0
    Timer_A_setCompareValue(TIMER_A1_BASE,
        TIMER_A_CAPTURECOMPARE_REGISTER_0,
        compVal
        );
}
